unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ImgList, ToolWin, ComCtrls, StdCtrls, ExtCtrls, ActnList, Buttons,
  Grids, IniFiles, ValEdit;

//  exports
//  GetMemoryManager name 'GetMemoryManager';

type FT_Result = Integer;

type
  TdescID = record
  ID: Integer;
  Decription: String;
end;

type
  TfrmMain = class(TForm)
    StatusBar1: TStatusBar;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Panel1: TPanel;
    Help1: TMenuItem;
    ActionList1: TActionList;
    FTPort_Configure: TAction;
    Timer1: TTimer;
    FTSendFile: TAction;
    FTReceiveFile: TAction;
    FTQuit: TAction;
    FTResend: TAction;
    SndRxvCmp: TAction;
    Exit1: TMenuItem;
    Panel2: TPanel;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Panel8: TPanel;
    SpeedHelp: TSpeedButton;
    Oddelovac4: TBevel;
    OpenDialog2: TOpenDialog;
    ReceiveBox: TGroupBox;
    Label5: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    lblTime: TLabel;
    lblID: TLabel;
    lblData: TLabel;
    TransmitBox: TGroupBox;
    btnTransmit0: TBitBtn;
    btnStop0: TBitBtn;
    editData: TEdit;
    editID: TEdit;
    Label6: TLabel;
    Label11: TLabel;
    editTime: TEdit;
    Label17: TLabel;
    PeriodBox: TCheckBox;
    Label18: TLabel;
    RTRBox: TCheckBox;
    Label19: TLabel;
    GroupBox2: TGroupBox;
    SaveDialog2: TSaveDialog;
    SaveDialog3: TSaveDialog;
    SaveDialog4: TSaveDialog;
    btnInit: TSpeedButton;
    btnClear: TSpeedButton;
    btnPause: TSpeedButton;
    btnStop: TSpeedButton;
    ShowFrame: TCheckBox;
    Panel5: TPanel;
    Label7: TLabel;
    Label2: TLabel;
    Label8: TLabel;
    editTag: TEdit;
    editMask: TEdit;
    rb2_0A: TRadioButton;
    rb2_0B: TRadioButton;
    Panel7: TPanel;
    Label12: TLabel;
    CanMessPanel: TPanel;
    lblMessCount: TLabel;
    Label1: TLabel;
    Label15: TLabel;
    lblMessError: TLabel;
    Panel10: TPanel;
    Label13: TLabel;
    GroupBox8: TGroupBox;
    LowSpeed: TRadioButton;
    HighSpeed: TRadioButton;
    Panel13: TPanel;
    lblBitRate: TLabel;
    lblKbps: TLabel;
    ComboSpeed: TComboBox;
    ListeningCheckBox: TCheckBox;
    Panel14: TPanel;
    Label290: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ReceiveCanData(var Msg: TMsg; var Handled: Boolean);
    procedure SendCanData(MCx: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CanCountClear;
    procedure CanErrorShow;
    procedure CanErrorInc(Val: Byte);
    procedure CanErrorClear;
    procedure ErrorMessages(Text: String);
    procedure CanCountShow;
    procedure btnClearClick(Sender: TObject);
    procedure btnSend0Click(Sender: TObject);
    procedure btnStop0Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure btnInitClick(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
    procedure btnPauseClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

 {
  Mozne nastaveni
  Pamet Filtru .... AverageDataTime
  }
implementation

uses unitMy;

// Main initialize CAN link
// Test Ready
// Set time from actual time your PC
// Initialize Global Register Driver
// Initialize Receive Message Center
procedure InitCan(HighSpeed: Boolean; SpeedIndex: Integer; ListeningMod: Boolean; CAN_2_0A: Boolean; Tag, Mask: String); stdcall; External 'CANxx';

// Main Disable CAN link
// Disable Transmit MC
// Disable Receive MC
// Disable CAN driver
procedure DisableCan; stdcall; External 'CANxx';

// Data Transmit to CAN link
// MCx .... Message Center [0..7]
// Per .... Transmit Periode(Delay) [0..65525][ms]
// Sys .... Transmit Mode (1..One Transmit (time delay = per[ms]), 3..Periodic Transmit (period = per[ms]), 4..Imediately Transmit (no time delay), All + 8 .. Receive Transmit Frame
// RTR .... Transmit Data Frame(RTR=False)/Remote Frame(RTR=True)
// ID  .... CAN idetifier
// Count .. Transmit Data Count
// bData .. Transmit Data byte array
procedure TransmitCanData(CAN_2_0A: Boolean; MCx,Per,Sys: Integer; RTR: Boolean; ID,Count: Integer; bData: array of Byte); stdcall; External 'CANxx';

// Stop transmit data
// MCx = Message Centrum [0..7]
procedure DisableMC(MCx: Integer); stdcall; External 'CANxx';

// Disable All transmit data
procedure DisableMCAll; stdcall; External 'CANxx';

// Pause On=True/Off=False
procedure SetPause(State: Boolean); stdcall; External 'CANxx';

// Enable Timer
procedure EnableTimer; stdcall; External 'CANxx';

// Separate Get messages
function GetMessage(var MessData: array of Byte): Boolean; stdcall; External 'CANxx';

// Decode All message
// Test procesor Message (Start and CRC code)
// Flow Control (Receive Frame, Receive Error, Receive Acknowledgment)
procedure DecodeMessage(var Data: array of Byte; var fMessType, fHour, fMin, fSec, fMsec, fID, fCountData: Integer; var fRTR, fIDE: Boolean); stdcall; External 'CANxx';
//********************************************

const
  Administrator=False;
  AppName='CAN DLL start ';
  Version='V1.0';
  INI_FILE='CanStart.INI';
  cAdaptorResponse: array[0..10] of String =('Adaptor Ready','CAN Initialization','MC Initialization','OUT Initialization','Time Initialization','Res','CAN Disable','MC Disable','OUT Disable','Res','Pause');
  cMessTime: array[0..8] of Integer = (5000,2500,2000,1250,1000,500,250,125,2000);

  cReady = $00;
  cInitCan =$01;		  // Initialization CAN driver
  cInitMC0_7 = $02;	  // Initialization MC0-MC7
  cInitMC8_14	=	$03;	// Initialization MC8-MC14
  cInitTime =	$04;		// Initialization Time
  cDisCan	 	=	$06;		// Disable CAN driver
  cDisMC0_7	=	$07;		// Disable M0 - MC7 (Receive)
  cDisMC8_14 = $08;	  // Disable M8 - MC14 (Tranceive)
  cPause		=	$0A;	  // Pause receive and transceive
  dRxCanToUSB = $0B;  // Receive Can Data
  dTxCanToUSB = $0C;  // Transceive Can Data
  dErrToUSB = $0D;    // Can Error

var
  FilePath: String;
  FullPath: String;

  CountBuff: array [0..2,0..16383] of integer;
  AverBuff: array [0..16383] of real;
  CountPos: Integer;

  iFindStart: Integer;

  CanDataPos: Integer;
  ReceiveCount: Integer=0;

  Pause: Boolean;

  ErrStuff: Integer;
  ErrCRC: Integer;
  ErrForm: Integer;
  ErrAck: Integer;

{$R *.DFM}

procedure TfrmMain.FormCreate(Sender: TObject);
var INIFile: TIniFile;
    INIPath: String;
begin
  Application.HintHidePause:=5000;
  Application.OnMessage := ReceiveCanData;

  iFindStart:=1;
  // INI file
  INIPath:=ExtractFilePath(Application.ExeName);
  INIFile:=TIniFile.Create(INIPath+INI_FILE);
  FilePath:=INIFile.ReadString('PATH','File',INIPath);
  FullPath:=INIFile.ReadString('PATH','Ini','');
  ComboSpeed.ItemIndex:=INIFile.ReadInteger('CAN','Speed',5);
  ListeningCheckBox.Checked:=INIFile.ReadBool('CAN','Listening',False);
  editTag.Text:=INIFile.ReadString('CAN','Tag','0');
  editMask.Text:=INIFile.ReadString('CAN','Mask','0');
  rb2_0A.Checked:=INIFile.ReadBool('CAN','2.0A',True);
  rb2_0B.Checked:= not rb2_0A.Checked;
  INIFile.Free;

  Pause:=False;
end;

procedure TfrmMain.FormShow(Sender: TObject);
var S : String;
    x: Integer;
begin
  SaveDialog1.InitialDir := ExtractFilePath(Application.ExeName);
  OpenDialog1.InitialDir := ExtractFilePath(Application.ExeName);

  FTSendFile.Enabled := False;
  FTReceiveFile.Enabled := False;
  FTPort_Configure.Enabled := False;
  Timer1.Enabled := True;
  FTSendFile.enabled := False;
  FTReceiveFile.Enabled := False;
  FTResend.Enabled := False;
  SndRxvCmp.Enabled := False;
//  GetFTDeviceCount;
//  S := IntToStr(FT_Device_Count);
  Caption := AppName+Version;
end;

procedure TfrmMain.CanCountClear;
begin
  CanDataPos:=0;
end;

// Show Message count value
procedure TfrmMain.CanCountShow;
begin
  lblMessCount.Caption:=IntToStr(CanDataPos);
end;

// Show error text
procedure TfrmMain.ErrorMessages(Text: String);
begin
  StatusBar1.Panels[1].Text:=Text;
end;

procedure TfrmMain.CanErrorClear;
begin
  ErrStuff:=0;
  ErrCRC:=0;
  ErrForm:=0;
  ErrAck:=0;
end;

procedure TfrmMain.CanErrorInc(Val: Byte);
begin
  if (Val and $08)=$08 then Inc(ErrStuff);
  if (Val and $04)=$04 then Inc(ErrCRC);
  if (Val and $02)=$02 then Inc(ErrForm);
  if (Val and $01)=$01 then Inc(ErrAck);
end;

procedure TfrmMain.CanErrorShow;
begin
  lblMessError.Caption:=IntToStr(ErrStuff+ErrCRC+ErrForm+ErrAck);
  lblMessError.Hint:='Stuff: '+IntToStr(ErrStuff)+', CRC: '+IntToStr(ErrCRC)+', Form: '+IntToStr(ErrForm)+', Ack: '+IntToStr(ErrAck);
end;


// Time To String Conversion
function sDecodeTime(Hour, Min, Sec, Msec: Integer): string;
begin
  result:=IntToStr(Hour)+':'+sTwo(Min)+':'+sTwo(Sec)+'.'+sThree(Msec);
end;

// Data Byte array to String Conversion
function sDecodeData(Data: array of Byte; Count: Integer): string;
var Len,x: Integer;
    s: string;
begin
  s:='';
  if Count>8 then Count:=8;
  for x:=0 to Count-1 do s:=s+IntToHex(Data[x],2)+'  ';
  result:=s;
end;

procedure TfrmMain.ReceiveCanData(var Msg: TMsg; var Handled: Boolean);
var
  Zprava: array [0..1024] of char;
  Data: array [0..255] of Byte;
  MessType, Hour, Min, Sec, Msec, ID, CountData: Integer;
  RTR, IDE: Boolean;
begin
  if Msg.message = WM_USER + 123 then
  begin
    GlobalGetAtomName(Msg.wParam, Zprava, SizeOf(Zprava));
    lblTime.Caption:= Zprava;
    Handled := True;
  end;

  while GetMessage(Data) do
  begin
    DecodeMessage(Data, MessType, Hour, Min, Sec, Msec, ID, CountData, RTR, IDE);
    case MessType of
      // Receive Frame showing
      dRxCanToUSB, dTxCanToUSB:
      begin
        lblTime.Caption:=sDecodeTime(Hour,Min,Sec,Msec);
        lblID.Caption:=IntToHex(ID,8);
        lblData.Caption:=sDecodeData(Data,CountData);

        Inc(CanDataPos);
        CanCountShow;
      end;
      // Error showing
      dErrToUSB:
      begin
        CanErrorInc(Data[0]);
        CanErrorShow;
      end;
      // Staus Frame showing
      else StatusBar1.Panels.Items[1].Text:='  '+cAdaptorResponse[Data[0]];
    end;
  end;

  EnableTimer;
end;

// Config Transmit from Transmit Box
// MCx = Message Centrum [0..7]
procedure TfrmMain.SendCanData(MCx: Integer);
var Data: array [0..255] of byte;
    Count,ID,Per,Sys: Integer;
    RTR: Boolean;
begin
// ibn 1  if DevicePresent then
  begin
    try
      // Period(Delay) Time [0..65535][ms]
      Per:=StrToInt(editTime.Text);
      // Once(Sys=1),Periodic(Sys=3) or Imediately(Sys=4) Transmit Frame, Show Transmit Frame (Sys=Sys+8);
      if PeriodBox.Checked then Sys:=3 else Sys:=1;
      if ShowFrame.Checked then Sys:=Sys+$08;
      // Data(RTR=FALSE) or Remote(RTR=TRUE) Frame
      RTR:=RTRBox.Checked;
      // ID setting
      ID:=HexToInt(editID.Text);
      // Data and Count
      Count:=HexToArray(editData.Text,Data);
      // Transmit data to CAN Link  5

      TransmitCanData(rb2_0A.Checked, MCx,Per,Sys,RTR,ID,Count,Data);
    except
      Application.MessageBox('Convert data Error!','ERROR',MB_Ok+MB_ICONERROR);
    end;
  end
// ibn 1  else Application.MessageBox('Device Not Present! You must Plug-In USB Adaptor or '+#13#10+'Instal USB Driver and Restart your Computer.','Warning',MB_Ok+MB_ICONWARNING);
end;

// Clear count message
procedure TfrmMain.btnClearClick(Sender: TObject);
begin
  CanCountClear;
  CanCountShow;
  CanErrorClear;
  CanErrorShow;
end;

// Start Transmit Data from Message Centrum 0
procedure TfrmMain.btnSend0Click(Sender: TObject);
begin
  SendCanData(0);
end;

// Stop Transmit Data in Message Centrum 0
procedure TfrmMain.btnStop0Click(Sender: TObject);
begin
  DisableMC(0);
end;

// Main window Close
procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
var INIFile: TIniFile;
    INIPath: String;
begin
// ibn 1  Pause:=True;
// ibn 1  FTQuitExecute(Self);
// INI file
  INIPath:=ExtractFilePath(Application.ExeName);
  INIFile:=TIniFile.Create(INIPath+INI_FILE);
  INIFile.WriteString('PATH','File',FilePath);
  INIFile.WriteString('PATH','Ini',FullPath);
  INIFile.WriteInteger('CAN','Speed',ComboSpeed.ItemIndex);
  INIFile.WriteBool('CAN','Listening',ListeningCheckBox.Checked);
  INIFile.WriteString('CAN','Tag',editTag.Text);
  INIFile.WriteString('CAN','Mask',editMask.Text);
  INIFile.WriteBool('CAN','2.0A',rb2_0A.Checked);
  INIFile.Free;
end;

// Application Exit
procedure TfrmMain.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.btnInitClick(Sender: TObject);
begin
  InitCan(HighSpeed.Checked, ComboSpeed.ItemIndex, ListeningCheckBox.Checked, rb2_0A.Checked, editTag.Text, editMask.Text);
end;

procedure TfrmMain.btnStopClick(Sender: TObject);
begin
  DisableCan;
end;

procedure TfrmMain.btnPauseClick(Sender: TObject);
begin
  Pause:= not Pause;
  SetPause(Pause);
end;

end.
